pipeline {
    
  agent {label 'my_slave'}  
  tools {
    maven 'Maven3'
  }
  stages {
    stage ('Clone Sources') {
        steps{
          checkout([$class: 'GitSCM', branches: [[name: '*/master']], doGenerateSubmoduleConfigurations: false, extensions: [], submoduleCfg: [], userRemoteConfigs: [[credentialsId: '', url: 'https://gitlab.com/ossama.mahjour97/myawesomeangularapprepo']]])      
        }
    }
    stage ('Build') {
      steps {
      sh 'mvn -f MyAwesomeApp/pom.xml clean install' 
      }
    } 
    /* 
    stage ('Code Quality scan')  {
        steps{
            withSonarQubeEnv('SonarQube') {
            sh 'mvn -f MyAwesomeApp/pom.xml sonar:sonar'
        }
        }
    }
   
    stage("Quality Gate"){
        steps{
            
            timeout(time: 1, unit: 'HOURS') {
                waitForQualityGate abortPipeline: true
              }
      } 
      
    }
    */
    stage ('Docker Build') {
        steps{
            script {
         // Build and push image with Jenkins' docker-plugin
               withDockerRegistry([credentialsId: "dockerhub", url: "https://index.docker.io/v1/"]) {
               image = docker.build("ossama97/mywebapp", "MyAwesomeApp")
               image.push()    
            }
        }
        }
    }
        
     stage('Deploy To Prod') { 
         steps { 
             timeout(time: 20, unit: 'SECONDS') {
                 input('Continue to Deploy?')
                 }
                  } }
      
      stage ('K8S Deploy') {
        steps{
          
                kubernetesDeploy(
                    configs: 'MyAwesomeApp/springboot-lb.yaml',
                    kubeconfigId: 'K8S',
                  //  enableConfigSubstitution: true
                    )                 
        }
        }

      stage ('Slack notification'){
        steps {
                slackSend baseUrl: 'https://hooks.slack.com/services/', 
                channel: 'jenkins-pipeline', 
                color: 'good', 
                message: 'Votre déploiement est réussi vous pouvez accéder a votre application par url:acdd18dc015f543959e0f71045c77752-885978513.us-east-2.elb.amazonaws.com:8085', 
                tokenCredentialId: 'f17426ff-9323-42f5-9c7c-98897ff3c7e0', 
                username: 'Ossama MAHJOUR'
        }
    }  
}



}



